controllers/MapController.php
<?php

namespace app\controllers;

use app\models\District;
use Yii;
use yii\web\Controller;
use yii\filters\VerbFilter;
use yii\web\Response;

/**
 * MapController implements the CRUD actions for DistrictGeoData model.
 */
class MapController extends Controller
{
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['post'],
                ],
            ],
        ];
    }

    public function actionJson(){
        $data = District::getProjectsMapData();
        \Yii::$app->response->format = Response::FORMAT_JSON;
        return $data;
    }

    public function actionTest(){
        \Yii::$app->response->format = Response::FORMAT_JSON;
        return District::getMaxProjectCount() + 2;
    }
}

controllers/ProjectsController.php
<?php

namespace app\controllers;

use app\models\District;
use app\models\FinancingSource;
use app\models\Organization;
use Yii;
use app\models\Project;
use app\models\search\Project as ProjectSearch;
use yii\helpers\ArrayHelper;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * ProjectsController implements the CRUD actions for Project model.
 */
class ProjectsController extends Controller
{
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['post'],
                ],
            ],
        ];
    }

    /**
     * Lists all Project models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new ProjectSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', ArrayHelper::merge([
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ], $this->formData()));
    }

    /**
     * Displays a single Project model.
     * @param string $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Finds the Project model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param string $id
     * @return Project the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Project::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }

    public function actionInDistrict($id){
        $searchModel = new ProjectSearch();
        $dataProvider = $searchModel->searchDistrict(Yii::$app->request->queryParams, $id);

        return $this->render('in-district', ArrayHelper::merge([
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
            'district' => District::findOne($id),
            'districts' => ArrayHelper::map(District::find()->all(), 'district_id', 'district'),
        ], $this->formData()));
    }

    private function formData(){
        return [
            'organisations'=>ArrayHelper::map(Organization::find()->all(), 'organization_id', 'organization_name'),
            'financiers'=>ArrayHelper::map(FinancingSource::find()->all(), 'financing_source_id', 'financing_source'),
        ];
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;

class SiteController extends Controller
{
    public $defaultAction = 'map';

    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    public function actionIndex()
    {
        return $this->render('index');
    }

    public function actionLogin()
    {
        if (!\Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        } else {
            return $this->render('login', [
                'model' => $model,
            ]);
        }
    }

    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }

    public function actionMap(){
       return $this->render('map');
    }

}

views/layouts/css.php
<?php
/**
 * Created by PhpStorm.
 * User: ronald
 * Date: 8/7/2015
 * Time: 6:47 PM
 */
use yii\helpers\Url; ?>
<link href="<?=Url::base()?>/css/stylesheets.css" rel="stylesheet" type="text/css" />

views/layouts/main.php
<?php
use yii\helpers\Html;
use yii\bootstrap\Nav;
use yii\bootstrap\NavBar;
use yii\helpers\Url;
use yii\widgets\Breadcrumbs;
use app\assets\AppAsset;

/* @var $this \yii\web\View */
/* @var $content string */

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0" />
    <?= Html::csrfMetaTags() ?>
    <title><?= Html::encode($this->title) . ' - '. Yii::$app->name ?></title>
    <?php $this->head() ?>
    <?=Yii::$app->controller->renderPartial('//layouts/css')?>

</head>
<body>

<?php $this->beginBody() ?>
    <div class="wrap">
        <?php
            NavBar::begin([
                'brandLabel' => Yii::$app->name,
                'brandUrl' => Yii::$app->homeUrl,
                'options' => [
                    'class' => 'navbar-inverse navbar-fixed-top',
                ],
            ]);
            echo Nav::widget([
                'options' => ['class' => 'navbar-nav navbar-right'],
                'items' => [
                    ['label' => 'Map', 'url' => ['/'], 'active'=>in_array(Yii::$app->controller->route, ['site/index', 'site/map'])],
                    ['label' => 'Projects', 'url' => ['/projects'], 'active'=>(Yii::$app->controller->id == 'projects')],
                    Yii::$app->user->isGuest ?
                        ['label' => 'Login', 'url' => Yii::$app->user->loginUrl] :
                        [
                            'label' => 'Hello ' . Yii::$app->user->identity->username,
                            'items'=> [
                                ['label'=>'Log Out', 'url' => ['/site/logout'],'linkOptions' => ['data-method' => 'post']]
                            ],
                        ],
                ],
            ]);
            NavBar::end();
        ?>

        <div class="container">
            <?= Breadcrumbs::widget([
                'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
            ]) ?>
            <?= $content ?>
        </div>
    </div>

    <footer class="footer">
        <div class="container">
            <p class="pull-left">&copy;
                <?=Html::a(Yii::$app->params['app-vendor'], Yii::$app->params['app-vendor-website'])?> <?= date('Y') ?></p>
            <p class="pull-right"><?= Yii::powered() ?></p>
        </div>
    </footer>

<?php $this->endBody() ?>
<?=Yii::$app->controller->renderPartial('//layouts/scripts')?>
<?=(Yii::$app->controller->route == 'site/map')?Yii::$app->controller->renderPartial('//layouts/map'):''?>
<script>
    $('#district-select').on('change', function(){
        window.location = '<?=Url::toRoute('/projects/in-district')?>?id=' + this.value;
    });
</script>
</body>
</html>
<?php $this->endPage() ?>

views/layouts/map.php
<?php
/**
 * Created by PhpStorm.
 * User: ronald
 * Date: 8/7/2015
 * Time: 7:23 PM
 */
use app\models\District;
use yii\helpers\Url; ?>
<script src="http://code.highcharts.com/maps/highmaps.js"></script>
<script src="http://code.highcharts.com/maps/modules/exporting.js"></script>
<script src="http://code.highcharts.com/mapdata/countries/ug/ug-all.js"></script>

<script>
    $(function () {

        $.ajax({
            url: '<?=Url::toRoute('/map/json')?>',
            type: 'get',
            dataType: 'json',
            cache: false,
            success: initialiseMap,
            async:true,
        });

    });

    function initialiseMap(data){
        $('#map-ug').innerHTML='';

        $('#map-ug').highcharts('Map', {

            title : {
                text : 'Projects in Districts'
            },

            subtitle : {
                text : 'Click a district to see projects under it'
            },

            mapNavigation: {
                enabled: true,
                buttonOptions: {
                    verticalAlign: 'bottom'
                }
            },

            colorAxis: {
                min: 0,
                max: <?=District::getMaxProjectCount()?>
            },

            series : [{
                data : data,
                mapData: Highcharts.maps['countries/ug/ug-all'],
                joinBy: 'hc-key',
                name: 'Projects in:',
                states: {
                    hover: {
                        color: '#BADA55'
                    }
                },
                dataLabels: {
                    enabled: true,
                    format: '{point.name}'
                },
                point: {
                    events:{
                        click: function (event) {
                            window.location = this.url;
                        }
                    }
                }
            }]
        });
    }

</script>

views/layouts/scripts.php
<?php
/**
 * Created by PhpStorm.
 * User: ronald
 * Date: 7/26/15
 * Time: 11:59 AM
 */

use yii\helpers\Url; ?>

<script type='text/javascript' src='<?=Url::base()?>/js/plugins/jquery/jquery-ui-1.10.3.custom.min.js'></script>
<script type='text/javascript' src='<?=Url::base()?>/js/plugins/jquery/jquery-migrate-1.2.1.min.js'></script>
<script type='text/javascript' src='<?=Url::base()?>/js/plugins/jquery/globalize.js'></script>
<script type='text/javascript' src='<?=Url::base()?>/js/plugins/other/excanvas.js'></script>

<script type='text/javascript' src='<?=Url::base()?>/js/plugins/other/jquery.mousewheel.min.js'></script>

<script type='text/javascript' src='<?=Url::base()?>/js/plugins/bootstrap/bootstrap.min.js'></script>

<script type='text/javascript' src='<?=Url::base()?>/js/plugins/cookies/jquery.cookies.2.2.0.min.js'></script>

<script type='text/javascript' src='<?=Url::base()?>/js/plugins/jflot/jquery.flot.js'></script>
<script type='text/javascript' src='<?=Url::base()?>/js/plugins/jflot/jquery.flot.stack.js'></script>
<script type='text/javascript' src='<?=Url::base()?>/js/plugins/jflot/jquery.flot.pie.js'></script>
<script type='text/javascript' src='<?=Url::base()?>/js/plugins/jflot/jquery.flot.resize.js'></script>

<script type='text/javascript' src='<?=Url::base()?>/js/plugins/epiechart/jquery.easy-pie-chart.js'></script>
<script type='text/javascript' src='<?=Url::base()?>/js/plugins/sparklines/jquery.sparkline.min.js'></script>

<script type='text/javascript' src='<?=Url::base()?>/js/plugins/mcustomscrollbar/jquery.mCustomScrollbar.min.js'></script>

<script type='text/javascript' src="<?=Url::base()?>/js/plugins/uniform/jquery.uniform.min.js"></script>

<script type='text/javascript' src="<?=Url::base()?>/js/plugins/fullcalendar/fullcalendar.min.js"></script>

<script type='text/javascript' src='<?=Url::base()?>/js/plugins/shbrush/XRegExp.js'></script>
<script type='text/javascript' src='<?=Url::base()?>/js/plugins/shbrush/shCore.js'></script>
<script type='text/javascript' src='<?=Url::base()?>/js/plugins/shbrush/shBrushXml.js'></script>
<script type='text/javascript' src='<?=Url::base()?>/js/plugins/shbrush/shBrushJScript.js'></script>
<script type='text/javascript' src='<?=Url::base()?>/js/plugins/shbrush/shBrushCss.js'></script>
<script type='text/javascript' src='<?=Url::base()?>/js/plugins/maskedinput/jquery.maskedinput-1.3.min.js'></script>

<script type='text/javascript' src='<?=Url::base()?>/js/plugins/select/select2.min.js'></script>

<script type='text/javascript' src='<?=Url::base()?>/js/plugins.js'></script>
<script type='text/javascript' src='<?=Url::base()?>/js/charts.js'></script>

<script type='text/javascript' src='<?=Url::base()?>/js/actions.js'></script>